#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int N = (int)1e5 + 117;
const int INF = (int)1e9 + 117;

vector<pair<int, int>> g[N];
vector<pair<int, int>> e;
vector<int> cc;

ll dp[2][N]{};
bool used[N]{};

void dfs(int v, int p_id) {
    used[v] = 1;
    for (auto& [to, id] : g[v]) {
        if (!used[to]) {
            dfs(to, id);

            dp[0][v] = max(dp[1][to], dp[0][v]);
            dp[1][v] += dp[0][to];
        }
    }

    if (p_id != -1)
        dp[1][v] += cc[p_id];

    if (g[v].size() == 1) {
        if (p_id != -1) dp[1][v] = cc[p_id];
        dp[0][v] = 0;
    }
}

inline int solve() {
    int n, k;
    cin >> n >> k;

    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        --x;
        int w;
        cin >> w;
        g[i].push_back({ x, (i - 1) << 1 });
        g[x].push_back({ i, (i - 1) << 1 | 1 });
        e.push_back({ i, x });
        e.push_back({ x, i });
        cc.push_back(w);
        cc.push_back(w);
    }

    if (k == 1) {
        dfs(0, -1);

//        for (int i = 0; i < 2; ++i) {
//            for (int j = 0; j < n; ++j) {
//                cout << dp[i][j] << " ";
//            }
//            cout << "\n";
//        }

        cout << max(dp[1][0], dp[0][0]) << "\n";
        return 0;
    }

    pair<int, ll> ans = { 0, 0 };

    for (int mask = 1; mask < (1 << (n - 1)); ++mask) {
        int cnt = 0;
        ll cost = 0;
        bool ok = 1;
        for (int i = 0; i < n - 1; ++i) {
            if (mask & (1 << i)) {
//                cerr << i << " ";
                ++cnt;
                cost += cc[i << 1];

                int kk = 0;
                for (auto [v, id] : g[e[i << 1].first]) {
//                    if (id & 1) --id;
                    if (mask & (1 << (id / 2))) ++kk;
                }
                int kkk = 0;
                for (auto [v, id] : g[e[i << 1].second]) {
//                    if (id & 1) --id;
                    if (mask & (1 << (id / 2))) ++kkk;
                }

                if (kk > k || kkk > k) {
//                    cnt = -INF;
//                    cost = INT64_MAX;
                    ok = 0;
                    break;
                }
            }
        }

        if (!ok) continue;

        if (ans.first < cnt) {
            ans.first = cnt;
            ans.second = cost;
        }

        if (ans.first == cnt && ans.second > cost) {
            ans.second = cost;
        }
    }
    cout << ans.first << " " << ans.second << "\n";

    return 0;
}

signed main() {
#ifdef __WIN32__
    freopen("C:\\Users\\olymp2\\CLionProjects\\untitled\\input.txt", "r", stdin);
    freopen("C:\\Users\\olymp2\\CLionProjects\\untitled\\output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) solve();
//    while (t--) stupid();
    return 0;
}
